C      PROGRAM SMTST4
C
C  This program is designed for testing SMART-algorithm on integration
C  of different types functions over multidimensional space.
C  Authors:  G.Takhtamyshev,  T.Merkulova.
C  Date of last changes:  15 April '97.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/SMKEYS/KP(20),KY(20) /DELTAC/AC(5,10)
     A  /PI/PI,TPI,HPI,PI2,SQPI /EXACT/EXACT(10)
     B  /SMPARS/SMP(5) /KF/KF /NEMPTY/NEMPTY 
     C  /ABC/ABC(10),LABC(10)
       DIMENSION X(100),ALIM(100),BLIM(100)
       EXTERNAL FUNC
       DATA ALIM,BLIM/100*0.D0,100*1.D0/
C
      OPEN(UNIT=30,FILE='smtst.dat',STATUS='OLD')
      READ(30,80) ABC,LABC
   80 FORMAT(5F10.0/5F10.0/10I5)
        KPR2 = LABC(5)
        IF (KPR2.EQ.0) PRINT 90, ABC, LABC
   90   FORMAT(2(1X,' ABC=',5G12.5/),1X,'LABC=',10I6)
      CLOSE(UNIT=30)
C  KF - type of function
       KF = LABC(1)
C  KDIM - dimension of hypercube
       KDIM = LABC(2)
C  NVAR - number of variant
       NVAR = LABC(3)
       PI=3.1415926
       TPI=2.*PI
       HPI=0.5*PI
       PI2=PI*PI
       SQPI = DSQRT(PI)
       IF (NVAR.EQ.0) GO TO 5
       DO 4 ISKIP=1,NVAR
    4  CALL RANECU(X,100)
    5  CONTINUE
C
       PRINT 91,KF,KDIM,NVAR
  91   FORMAT(///1X,'SMTST4--> 'I2'/'I2'/'I2,'  (KF/KDIM/NVAR)')
       EPS = ABC(1)
       DO 10 I = 1, 100
       ALIM(I) = 0.
   10  BLIM(I) = 1.
C
       CALL SMART2(KDIM,ALIM, BLIM,FUNC,EPS,AINT)
C
       PRINT 92,EXACT(KF),AINT,SMP(3)
   92  FORMAT(/5X,'Exact='G15.6,'   Res=',G15.6,'   Dzeta='G10.3//)
C
       END
 
      SUBROUTINE SMART2(KDIM, ALIM, BLIM, FUNC, EPSUS, AINT)
C
C  This program is designed for integration
C  of different types functions over multidimensional space.
C  Authors:  G.Takhtamyshev,  T.Merkulova.
C  Date of last changes: 16 September '96.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /SMKEYS/KP(20),KY(20) /DELTAC/AC(5,10)
     A  /SMPARS/SMP(5) /NEMPTY/NEMPTY /EXACT/EXACT(10)
     B  /VOLUME/VOLUME /INP2/INP2 
     C  /ABC/ABC(10),LABC(10)
       DIMENSION ALIM(1),BLIM(1),RES(6)
       EXTERNAL FUNC
       DATA ICALL /0/
       DATA LSET,NSETS,NSUPS /1000,2*1024/
C
      IF (ICALL.EQ.0) THEN
         ZERO = 0.
         KF = LABC(1)
         OPEN(UNIT=20, FILE='smart.dat', STATUS='OLD')
         READ (20,80) MAXSET, INP2
   80    FORMAT(2I10)
         IF (INP2.EQ.0) CLOSE (UNIT=20)
      ENDIF
      IF (MAXSET.LE.0) MAXSET = 1050000
      ICALL = ICALL + 1
C
C  Accuracy will be calculated after each JRES sets.
C  JRES can be defined via KY(9). Default value: 1.
C
      JRES = 1
      IF (KY(9).GE.1) JRES = KY(9)
       VOLUME = 1.
       DO 11 IVOL = 1, KDIM
   11  VOLUME = VOLUME*(BLIM(IVOL)-ALIM(IVOL))
C       PRINT 901, VOLUME
C  901  FORMAT(5X,'Volume=',G12.4)
       KSTRT=1
       CALL DELTAS(0,ZERO)
       KSET=KSTRT
       ISET=0
       IRES=0
C
       DO 40 ISUP = 1, NSUPS
       DO 30 IST = 1, NSETS
       ISET=ISET+1
       KRES=0
       KP(1) = 0
       IF(ISET.EQ.KSET) THEN
         KSET=2*KSET
         IF (KP(18).EQ.1) KP(1)=1
         KRES=1
      ENDIF
C
       DO 20 L = 1, LSET
C
C   FUNC should be called like F=FUNC(X) (only one parameter).
C
      IF (KP(15).GE.1) THEN
        KP(14) = 0
        IF (L.LE.KP(15)) KP(14) = 1
      ENDIF
       CALL SMART1(KDIM,ALIM,BLIM,FUNC,Z)
       CALL DELTAS(1,Z)
   20  CONTINUE
      IF (MAXSET.GE.1.AND.ISET.GE.MAXSET) GO TO 50
      IF (ISET.EQ.JRES*(ISET/JRES).OR.KRES.EQ.1) THEN
        CALL DELTAS(-2,ZERO)
        IRES=IRES+1
        RES(1)=ISET
        RES(2) = (AC(2,1)/AC(1,1))*VOLUME
        RES(3) = DABS(AC(5,1))
        IF (KRES.EQ.1) THEN
          RES(4) = 0.
          IF (AC(5,1).GT.0.) RES(4) = DLOG10(RES(3))
          RES(5) = SMP(3)
          RES(6) = RES(2) - EXACT(KF)
          IF (EXACT(KF).GT.0.) RES(6) = RES(6)/EXACT(KF)
          IF (KP(18).EQ.1) PRINT 91, RES
   91     FORMAT(1X,'-res-',F10.0,G16.6,4G12.4)
        ENDIF
        EPS = RES(3)
        IF (ISET.GE.10.AND.EPS.LE.EPSUS) GO TO 50
      ENDIF
   30  CONTINUE
   40  CONTINUE
   50  AINT = (AC(2,1)/AC(1,1))*VOLUME
       DELT = AINT - EXACT(KF)
       IF (KP(18).EQ.1) PRINT 92, ISET,AINT,DELT,EPS,EPSUS,SMP(3)
   92  FORMAT(/1X,'Nsets=',I8,'  Int=',G16.8,'  Delt=',G12.4/
     F   10X,'  Eps=',F6.3,'  Epsus=',F6.3,'   Dzeta='G10.3/)
C       PRINT 93,NEMPTY
C   93  FORMAT(7X,55(1H-)/,7X,'Empty sets:'I8///)
       KY(3) = 1
       RETURN
       END
 
      SUBROUTINE SMART1(KDIM,ALIM,BLIM,FUNC,FWD)
C
C--    Version for both-signs-function
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/SMKEYS/KP(20),KY(20)
     A  /SMPARS/FMAX,RINT,DZETA,FWMAX,DZETAM
     B  /NEMPTY/NEMPTY /INP2/INP2
C     B  /SM1/RL(20,30) /SM2/A(20,30) /SM3/FSUM(20,30) /SM4/XAV(20,30)
C     C  /SM5/X(30) /SM6/ILD(30) /SM7/JOS(30) /SM8/NO(30) /SM9/WD(30)
C     D  /SM10/RRL(20)
      DIMENSION RL(20,30),A(20,30),FSUM(20,30),XAV(20,30),
     D  X(30),ILD(30),JOS(30),NO(30),WD(30),RRL(20)
      DIMENSION ALIM(1),BLIM(1),RVEC(100),FCT(5),FACT(5),V(30)
      DATA LEN/1/
      DATA N, NSET,FACT,KD
     D   /10, 1000,  3.,  5.,   2.,   10.,  0.1,  30/
      DATA KP/1,8*0,1,7*0,1,0,0/, KY/1,4*0,1,0,0,5,11*0/
      DATA INIT/0/
      IF (KY(3).GE.1) GO TO 100
C
C-- If SMART is called two or more times for different tasks, KY(3)=1
C-- should be set before each new call in order to clean all old information.
C
      IF (INIT) 1,1,2
    1 INIT=1
      IF (INP2.EQ.1) THEN
        READ (20,83) N, KY, KP, FCT
   83   FORMAT(I5/20I2/20I2/5F10.0)
        DO 9 I=1,5
        IF (FCT(I).GE.0.) FACT(I)=FCT(I)
    9   CONTINUE
        INP2 = 0
        CLOSE (UNIT=20)
      ENDIF
  100 KY(3)=0
      IP=0
      NALL=0
      NAL1=0
      NAL2=0
      ISET=0
      IEX=0
      KMAX=0
      FMAX=0.
      FWMAX=0.
      FMIN = 0.
      FWMIN = 0.
      FSET=0.
      SINT=0.
      NEMPTY = 0
      IF (KP(19).EQ.1) THEN
        PRINT 901,KDIM,KD,N,NSET,FACT
  901   FORMAT(/10X,'********* SMART1 ****************'/
     F  '  max nbins=20, max kdim=30 in this version, KDIM=', I3/
     F  3I5,5G12.4)
        PRINT 906,KY,KP
  906   FORMAT(1X,'*KY: '20I2/1X,'*KP: '20I2)
      ENDIF
      DO 3 ID=1,KD
      A(1,ID)=0.
      DO 4 IL=2,N
C
C  KY(4)=1 means, that user wants to start from (or to use) pre-defined
C  binning and the binning is already set in the COMMON-block /A/A(20,30).
C
      IF (KY(4).NE.1) A(IL,ID)=A(IL-1,ID)+1./N
    4 RL(IL-1,ID)=A(IL,ID)-A(IL-1,ID)
      RL(N,ID)=1.-A(N,ID)
      DO 5 IL=1,N
      XAV(IL,ID)=0.
      FSUM(IL,ID)=0.
    5 CONTINUE
    3 CONTINUE
      IF (KY(10).EQ.1) CALL STAT(0, KDIM, X, FDWD)
    2 CONTINUE
C--->
      IP=IP+1
C
C-- KY(6)=1 permits admixture of uniformly-distributed points.
C-- The relative number of such points is defined by value FACT(5).
C
      KUNIF = 0
      IF (KY(6).NE.0) THEN
          CALL RANECU(RVEC,1)
          IF (RVEC(1).LE.FACT(5)) THEN
              KUNIF=1
              NAL1=NAL1+1
          ENDIF
      ENDIF
      IF (KUNIF.EQ.0) NAL2=NAL2+1
C--->
      IF (KDIM.GT.KD) THEN
        IF (IEX.EQ.0) PRINT 194,KD,KDIM
  194   FORMAT(1X,23HMAX ARRAYS DIMENSION IS,I5,6H   NOT,I10)
        IEX=1
        RETURN
      ENDIF
   21 CALL RANECU(RVEC,KDIM)
      WSM = 1.
      IF (KUNIF.EQ.1) THEN
        DO 122 ID=1,KDIM
  122   X(ID) = RVEC(ID)
        GO TO 24
      ENDIF
      DO 123 ID=1,KDIM
      IL=RVEC(ID)*N+1
      IF (IL.GT.N) IL=N
      W=RL(IL,ID)*N
      X(ID)=A(IL,ID)+RVEC(ID)*W-(IL-1)*RL(IL,ID)
      WSM = WSM*W
      ILD(ID) = IL
      IF (X(ID).LE.0..OR.X(ID).GE.1.) THEN
C-- KY(7)=1 permits random numbers to be equal 0. or 1.
        IF ((X(ID).EQ.0..OR.X(ID).EQ.1.).AND.KY(7).EQ.0) GO TO 21
        IF (KP(10).GE.1) PRINT 99,IP,ID,IL,KUNIF,X(ID)
   99   FORMAT(1X,'*SMART -  xi out of range',4I5,G16.8)
        GO TO 21
      ENDIF
C
  123 CONTINUE
   24 CONTINUE
C
      DO 124 IV = 1, KDIM
  124 V(IV) = ALIM(IV)+(BLIM(IV)-ALIM(IV))*X(IV)
      F = FUNC(V)
C
C   KY(8)= 1 for integrating positive part of the function
C         -1 for integrating negative part of the function
C          0 for integrating the whole function
C
      IF (KY(8).EQ.1.AND.F.LT.0.) F=0.
      IF (KY(8).EQ.-1) THEN
        IF (F.GT.0.) F=0.
        F = -F
      ENDIF
      IF (KP(14).EQ.1) PRINT 903,IP,F,(X(ID),ID=1,KDIM)
  903 FORMAT(1X,'***Smart1',I5,G15.6/(5X,5G12.4))
C
      AF = DABS(F)
      FWD = F*WSM
      AFWD = AF*WSM
      FDWD = AFWD
      IF (KY(10).EQ.1) CALL STAT(IP, KDIM, X, FDWD)
      SINT=SINT+AFWD
      IF (F.GT.FMAX) FMAX=F
      IF (F.LT.FMIN) FMIN = F
      IF (FWD.GT.FWMAX) FWMAX=FWD
      IF (FWD.LT.FWMIN) FWMIN = FWD
      IF (KUNIF.EQ.0) THEN
        DO 31 ID=1,KDIM
        IL=ILD(ID)
        FSUM(IL,ID)=FSUM(IL,ID)+AF
        XAV(IL,ID)=XAV(IL,ID)+X(ID)*AF
   31   CONTINUE
      ENDIF
      FSET=FSET+AF
C      F=WD(KK)
C      SMART=FWD
      IF (IP.LT.NSET) RETURN
C
C------- Set is over ---------------
C
      ISET=ISET+1
      NALL=NALL+NSET
C
C  Call Stat for calculation correlation matrix
C
      IF (KY(10).EQ.1) CALL STAT(-1, KDIM, X, FDWD)
      IF (FSET.GT.0.) GO TO 29
      IF (KP(17).EQ.1)
     P  PRINT 195,ISET,NALL,NAL1,NAL2,FSET,SINT
  195 FORMAT(1X,16H*SMART-EMPTY SET,4I8,2G12.4)
      IP=0
      NEMPTY = NEMPTY + 1
      RETURN
   29 FSET=0.
C      KDIM=KMAX
      AVMODF = SINT/(NSET*ISET)
      DZETA = AVMODF/(FMAX-FMIN)
      DZETAM = AVMODF/(FWMAX-FWMIN)
      IF (KP(1).GE.1)
     P  PRINT 90,ISET,NALL,NAL1,NAL2,FMAX,FMIN,DZETA,DZETAM
   90 FORMAT(1X,60(1H-)/1X,20(1H*),5X,'SMART',5X,20(1H*)/
     F  1X,3HSET,I8/
     F  1X,'  All points',12X,I10/1X,'  Unif. distributed:',4X,I10/
     F  1X,'  Non-unif. distributed:',I10/
     F  1X,' Fmax=',G11.4,'  Fmin=',G11.4,'  Dzeta=',G11.4 ,
     F  '   Dzetam=',G11.4)
C      IF (KP(13).GE.1) PRINT 193,KY
C   193 FORMAT(1X,5HKeys=,4X,20I2)
      MAXIOS=0
      DO 70 ID=1,KDIM
      FAV=0.
      FMN = FSUM(1,ID)
      FM1=0.
      KZERO=0
      DO 33 IL=1,N
      IF (FSUM(IL,ID).GT.0.) GO TO 35
      IF (KP(16).GE.1) PRINT 192,ISET,NSET,ID,IL
  192 FORMAT(1X,42H*SMART WARNING- NSET PROBABLY TOO SMALL   ,4I5)
      KZERO=1
      GO TO 36
   35 CONTINUE
      XAV(IL,ID)=XAV(IL,ID)/FSUM(IL,ID)
   36 RRL(IL)=RL(IL,ID)
      FSUM(IL,ID)=FSUM(IL,ID)*RL(IL,ID)*N
      FAV=FAV+FSUM(IL,ID)
      IF (FSUM(IL,ID).GT.FM1) THEN
        M1=IL
        FM1=FSUM(IL,ID)
      ENDIF
      IF (FSUM(IL,ID).LT.FMN) THEN
        MN=IL
        FMN=FSUM(IL,ID)
      ENDIF
   33 CONTINUE
      FAV=FAV/N
      FM2=0.
      FRST=0.
      DO 32 IL=1,N
      IF (IL.EQ.M1) GO TO 32
      FRST=FRST+FSUM(IL,ID)
      IF (FSUM(IL,ID).LE.FM2) GO TO 32
      M2=IL
      FM2=FSUM(IL,ID)
   32 CONTINUE
      IF (KZERO.EQ.0) GO TO 37
      IOS=2
      IF (KY(5).EQ.0) GO TO 39
      GO TO 38
   37 IOS=0
C--->
      IF (FM1.GE.FACT(1)*FMN) IOS=1
      IF (FM1.GT.FACT(2)*FAV.OR.FAV.GT.FACT(2)*FMN) IOS=2
   38 IF (FM1.GE.FRST*FACT(3)) IOS=3
   39 IF (IOS.GT.MAXIOS) MAXIOS=IOS
      JOS(ID)=IOS
      NOD=0
      IF (KP(2).GE.1) PRINT 94
      IF (KP(2).GE.1) PRINT 91,ID,IOS,FM1,M1,FMN,MN,FAV
   91 FORMAT(1X,5HIDIM=,I3,4X,20HSINGULARITY ORDER IS,I2,4X,
     1  10HMAX WEIGHT,E12.5,6H   BIN,I3,4X,10HMIN WEIGHT,E12.5,
     2   6H   BIN,I3,4X,4HFAV=,E12.5)
      IF (KP(3).GE.1) PRINT 95,(FSUM(IL,ID),IL=1,N)
   95 FORMAT(1X,3HFS=,5(1X,G10.4))
      IF (KP(4).GE.1) PRINT 97,(XAV(IL,ID),IL=1,N)
   97 FORMAT(1X,3HXAV,5G10.4)
      IF (KY(1).LE.0) GO TO 80
      IF (IOS.LE.0) GO TO 80
      IF (IOS-2) 40,50,60
C--------------- FIRST ORDER SINGULARITY -------------------
   40 CONTINUE
      A(1,ID)=0.
      DO 41 IL=2,N
      AN      =(FSUM(IL-1,ID)*XAV(IL-1,ID)+
     +  FSUM(IL,ID)*XAV(IL,ID))/(FSUM(IL-1,ID)+FSUM(IL,ID))
      A(IL,ID)=0.5*(A(IL,ID)+AN)
   41 CONTINUE
      DO 42 IL=2,N
      RL(IL-1,ID)=A(IL,ID)-A(IL-1,ID)
   42 CONTINUE
      RL(N,ID)=1.-A(N,ID)
      GO TO 80
C----------- SECOND ORDER -------------------------------
   50 CONTINUE
      RMIN = 0.
      ILMIN = 0
      DO 51 IL=2,N
      IF (IL.EQ.M1.OR.IL-1.EQ.M1) GO TO 51
      RR=FSUM(IL,ID)+FSUM(IL-1,ID)
      IF (ILMIN.EQ.0.OR.RR.LT.RMIN) THEN
        ILMIN = 1
        ILM=IL
        RMIN=RR
      ENDIF
   51 CONTINUE
      IF (RL(ILM-1,ID)/RL(ILM,ID).GE.FACT(4)) NOD=1
      IF (RL(ILM-1,ID)/RL(ILM,ID).LE.1./FACT(4)) NOD=1
      IF (NOD.GE.1) GO TO 80
      ILL=1
      A(1,ID)=0.
      DO 52 IL=2,N
      IF (IL.EQ.ILM) GO TO 52
      ILL=ILL+1
      IF (IL -1.EQ.M1) GO TO 53
      IF (IL -1.EQ.ILM) GO TO 54
      RL(ILL-1,ID)=RRL(IL-1)
      A(ILL,ID)=A(ILL-1,ID)+RL(ILL-1,ID)
      GO TO 52
   53 RL(ILL-1,ID)=0.5*RRL(IL-1)
      A(ILL,ID)=A(ILL-1,ID)+RL(ILL-1,ID)
      ILL=ILL+1
      RL(ILL-1,ID)=0.5*RRL(IL-1)
      A(ILL,ID)=A(ILL-1,ID)+RL(ILL-1,ID)
      GO TO 52
   54 RL(ILL-1,ID)=RRL(IL-1)+RRL(IL-2)
      A(ILL,ID)=A(ILL-1,ID)+RL(ILL-1,ID)
   52 CONTINUE
      IF (M1.NE.N) GO TO 55
      RL(N-1,ID)=0.5*RRL(N)
      A(N,ID)=A(N-1,ID)+RL(N-1,ID)
   55 RL(N,ID)=1.-A(N,ID)
      GO TO 80
C---------- THIRD ORDER ----------------------------------------
   60 CONTINUE
      A(1,ID)=0.
      IF (M1.EQ.1) GO TO 64
      IF (M1.EQ.N) GO TO 66
      ND=N-1
      IF (M1.EQ.2) GO TO 62
      DO 61 IL=3,M1
   61 RL(1,ID)=RL(1,ID)+RL(IL-1,ID)
   62 A(2,ID)=A(1,ID)+RL(1,ID)
      DO 63 ILL=2,ND
      RL(ILL,ID)=RL(M1,ID)/(ND-1.)
   63 A(ILL+1,ID)=A(ILL,ID)+RL(ILL,ID)
      RL(N,ID)=1.-A(N,ID)
      GO TO 80
   64 DO 65 ILL=2,N
      RL(ILL-1,ID)=RRL(M1)/(N-1.)
   65 A(ILL,ID)=A(ILL-1,ID)+RL(ILL-1,ID)
      RL(N,ID)=1.-A(N,ID)
      GO TO 80
   66 DO 67 ILL=3,N
   67 RL(1,ID)=RL(1,ID)+RL(ILL-1,ID)
      A(2,ID)=A(N,ID)
      DO 68 ILL=3,N
      RL(ILL-1,ID)=RL(M1,ID)/(N-1.)
   68 A(ILL,ID)=A(ILL-1,ID)+RL(ILL-1,ID)
      RL(N,ID)=1.-A(N,ID)
C----------------- PRINT -----------------------------------
   80 CONTINUE
      NO(ID)=NOD
      IF (KP(5).GE.1) PRINT 96,NOD
   96 FORMAT(1X,4HNOD=,I5)
      IF (KP(6).GE.1) PRINT 92,(A(IL,ID),IL=1,N)
   92 FORMAT(1X,3HA= ,5(1X,G10.4))
      IF (KP(7).GE.1) PRINT 93,(RL(IL,ID),IL=1,N)
   93 FORMAT(1X,3HL= 5(1X,G10.4))
      DO 81 IL=1,N
      XAV(IL,ID)=0.
   81 FSUM(IL,ID)=0.
   70 CONTINUE
      IF (KY(1).GE.1) FWMAX=0.
      IP=0
      IF (KP(8).GE.1) PRINT 98,MAXIOS
   98 FORMAT(1X,12HMAX SING ORD,I4)
      IF (KP(11).GE.1) PRINT 190,(JOS(J),J=1,KMAX)
  190 FORMAT(1X,9HSING ORD=,40I2)
      IF (KP(12).GE.1) PRINT 191,(NO(J),J=1,KMAX)
  191 FORMAT(1X,5HNODS=,4X,40I2)
      IF (KP(9).GE.1) PRINT 94
   94 FORMAT(1X,70(1H-))
      RETURN
      END
 
      SUBROUTINE STAT(KEY, KDIM, VECT, W)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /ABC/ABC(10),LABC(10)
     B  /SMKEYS/KP(20),KY(20)
      DIMENSION VECT(1), AV(20), CORR(20,20), SIG(20)
      DIMENSION A(20),COR(20,20),AL(20,20),R(20,20)
      DATA KDMAX/20/
      IF (KEY) 30, 10, 20
   10 IP = 0
      MPRNT = 1000*LABC(6)
      SUMW = 0.
      DO 12 I = 1, KDMAX
      A(I) = 0.
      SIG(I) = 0.
      DO 11 J = 1, KDMAX
      COR(I,J) = 0.
   11 CONTINUE
   12 CONTINUE
      RETURN
   20 IP = IP + 1
      SUMW = SUMW + W
      KM = KDIM
      IF (KM.GT.KDMAX) KM = KDMAX
      DO 25 I = 1, KM
      VI = VECT(I)
      A(I) = A(I) + W*VI
      DO 24 J = 1, I
      VJ = VECT(J)
      COR(I,J) = COR(I,J) + W*VI*VJ
   24 CONTINUE
   25 CONTINUE
      RETURN
   30 CONTINUE
      AVW = SUMW/(IP*1.)
      IF (KP(1).EQ.1)
     P  PRINT 91, IP, AVW
   91 FORMAT(1X,'Points',I10,'   Av_W=',G12.5)
      DO 35 I = 1, KM
      AV(I) = A(I)/SUMW
      DO 34 J = 1, I
      CORR(I,J) = COR(I,J)/SUMW
      AL(I,J) = CORR(I,J) - AV(I)*AV(J)
   34 CONTINUE
      SIG(I) = DSQRT(AL(I,I))
   35 CONTINUE
      DO 37 I = 1, KM
      DO 36 J = 1, I
      R(I,J) = AL(I,J)/(SIG(I)*SIG(J))
   36 CONTINUE
      IF (KP(1).EQ.1)
     P   PRINT 90, I, AV(I), SIG(I), (R(I,J),J=1,I)
   90 FORMAT(1X,I5,6G12.4/(30X,4G12.4))
   37 CONTINUE
      RETURN
      END
 
       SUBROUTINE RANECU(RVEC,LEN)
       REAL*8 RVEC(1)
C         Portable random number generator proposed by L'Ecuyer
C              in Comm. ACM 31:743 (1988)
C         slightly modified by F. James, 1988,to generate a vector
C         of pseudorandom numbers RVEC of length LEN
C      COMMON /IS/ISEED1,ISEED2
       DATA ISEED1,ISEED2/12345,67890/
C
       DO 100 I= 1,LEN
       K = ISEED1/53668
       ISEED1 = 40014*(ISEED1 - K*53668) - K*12211
       IF (ISEED1 .LT. 0) ISEED1=ISEED1+2147483563
C
       K = ISEED2/52774
       ISEED2 = 40692*(ISEED2 - K*52774) - K* 3791
       IF (ISEED2 .LT. 0) ISEED2=ISEED2+2147483399
C
       IZ = ISEED1 - ISEED2
       IF (IZ .LT. 1) IZ = IZ + 2147483562
C
       RVEC(I) = REAL(IZ) * 4.656613E-10
  100  CONTINUE
       RETURN
C
       ENTRY RECUIN(IS1,IS2)
       ISEED1 = IS1
       ISEED2 = IS2
       RETURN
C
       ENTRY RECUUT(IS1,IS2)
       IS1 = ISEED1
       IS2 = ISEED2
       RETURN
       END
 
      SUBROUTINE DELTAS(K,X)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/DELTAC/AC(5,10)
      DATA MAC/10/
      IF(K) 100,1,10
    1 IF(X.GT.0.5) MAC=X
      DO 2 I=1,MAC
      DO 2 J=1,5
    2 AC(J,I)=0.
      RETURN
   10 IF(K.GT.MAC) RETURN
      AC(1,K)=AC(1,K)+1.
      AC(2,K)=AC(2,K)+X
      AC(3,K)=AC(3,K)+X**2
      RETURN
  100 LUN=X
C      IF (K.EQ.-2) GO TO 110
C      IF (K.EQ.-3) GO TO 120
      DO 101 I=1,MAC
      RN=AC(1,I)
      IF(RN.LT.0.5) GO TO 101
      XAV=AC(2,I)/RN
      X2AV=AC(3,I)/RN
      DISP=X2AV-XAV**2
      IF (DISP.GT.0.) GO TO 102
      IF (K.EQ.-1)
     P  PRINT 94,I,RN,XAV,X2AV,DISP
   94 FORMAT(1X,14H***SMTHNG WRNG,I3,4G20.5)
      GO TO 101
  102 SDEV=DSQRT(DISP)
      DS=DSQRT(DISP/(2.*RN))
      AC(4,I)=SDEV/DSQRT(RN)
      AC(5,I)=AC(4,I)/XAV
      IF (K.EQ.-1)
     P  PRINT 93,I,RN,XAV,SDEV,DS,AC(4,I),AC(5,I)
   93 FORMAT(1X,11H***ACCURACY,I5,F9.0,3G18.8/44X,2G18.8)
  101 CONTINUE
      RETURN
C  110 READ (LUN) ((AC(J,I),J=1,5),I=1,MAC)
C      RETURN
C  120 WRITE (LUN) ((AC(J,I),J=1,5),I=1,MAC)
C      RETURN
      END
 
      FUNCTION FUNC(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /KF/KF
      DIMENSION X(1)
      GO TO (1,2,3,4,5,6,7,8), KF
    1 FUNC=FUNC1(X)
C       PRINT 901,FUNC,(X(I),I=1,5)
C  901  FORMAT(1X,'**FUNC='G15.6,5F10.4)
      RETURN
    2 FUNC=FUNC2(X)
      RETURN
    3 FUNC=FUNC3(X)
      RETURN
    4 FUNC=FUNC4(X)
      RETURN
    5 FUNC=FUNC5(X)
      RETURN
    6 FUNC = FUNC6(X)
      RETURN
    7 FUNC = FUNC7(X)
      RETURN
    8 FUNC = FUNC8(X)
      RETURN
C
       END
 
      FUNCTION FUNC1(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /ABC/ABC(10),LABC(10)
     A  /PI/PI,TPI,HPI,PI2,SQPI /EXACT/EXACT(10)
       DIMENSION RVEC(100), A(100,10), X(1)
       DATA INIT/0/
C
       IF(INIT.EQ.1) GO TO 2
       INIT=1
       KDIM = LABC(2)
       D = ABC(2)
       SIG = DSQRT(D)
       RO = ABC(3)
       NPK = LABC(4)
       PRINT 90,NPK,D,RO
   90  FORMAT(1X,'*FUNC1  peaks numb='I3'  D='G10.4'  RO='F6.3)
       EXACT(1) = 0.
       DO 10 IPK=1,NPK
       CALL RANECU(RVEC,KDIM)
       EX1 = 1.
       DO 9 J=1,KDIM
       RVJ = RVEC(J)
       FINT = DFREQ(RVJ/SIG) + DFREQ((1.-RVJ)/SIG) - 1.
       EX1 = EX1*FINT
   9   A(J,IPK)=RVJ
       EXACT(1) = EXACT(1) + EX1
       PRINT 91,IPK,(A(J,IPK),J=1,KDIM)
   91  FORMAT(1X,'Peak #'I3/(5X,5G12.5))
   10  CONTINUE
       PRINT 92, EXACT(1)
   92  FORMAT(/1X,'  Exact value of the integral:  ',G12.4)
       SQTPI = DSQRT(TPI)
       FACT=1.
       DO 5 I=1,KDIM
   5   FACT=FACT*SQTPI*SIG
       C1=1./D
       C2=RO*C1
   2   CONTINUE
C
       FUNC1 = 0.
       DO 20 IPK=1,NPK
       SUM=0.
       DO 12 I=1,KDIM
       DO 11 J=1,KDIM
       C=C2
       IF(I.EQ.J) C=C1
  11   SUM=SUM+C*(X(I)-A(I,IPK))*(X(J)-A(J,IPK))
  12   CONTINUE
       IF(SUM.LT.200.) GO TO 13
       F=0.
       GO TO 14
  13   F = DEXP(-0.5*SUM)
  14   FUN=F/FACT
       FUNC1 = FUNC1 + FUN
   20  CONTINUE
       RETURN
       END
 
      FUNCTION FUNC2(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /EXACT/EXACT(10)
     A   /ABC/ABC(10),LABC(10)
      DIMENSION A(100,10), X(1)
      DATA INIT/0/
      IF (INIT.GE.1) GO TO 2
      INIT=1
      KDIM = LABC(2)
      NF = LABC(4)
      B = ABC(2)
      PRINT 91, NF,B
   91 FORMAT(5X,'Function 2: Sum of'I3'  exp(-b*abs(x-a(j)))  b='
     1  F8.3)
      DO 10 J=1,NF
      CALL RANECU(A(1,J),KDIM)
      PRINT 90,J,(A(K,J),K=1,KDIM)
   90 FORMAT(1X,'PEAK NUMBER ='I2/5X'A='5G12.4/(7X,5G12.4))
   10 CONTINUE
      EXACT(2)=0.
      DO 12 J=1,NF
      PROD=1.
      DO 11 K=1,KDIM
   11 PROD=PROD*(2.-DEXP(-B*A(K,J))-DEXP(-B*(1.-A(K,J))))
   12 EXACT(2)=EXACT(2)+PROD
    2 CONTINUE
      FUNC2=0.
      DO 30 J=1,NF
      F=1.
      DO 20 K=1,KDIM
   20 F=F*B*DEXP(-B*ABS(X(K)-A(K,J)))
      FUNC2=FUNC2+F
   30 CONTINUE
      RETURN
      END
 
      FUNCTION FUNC3(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PI/PI,TPI,HPI,PI2,SQPI
     A   /ABC/ABC(10),LABC(10)
      DIMENSION X(1)
      DATA INIT/0/
      IF (INIT.GE.1) GO TO 2
      INIT=1
      KDIM = LABC(2)
      FR = ABC(2)
      MP = LABC(4)
      PRINT 90,FR,MP
   90 FORMAT(1X,'*FUNC3   FREQ=',F8.2,'   MP=',I4)
    2 CONTINUE
      F=1.
      DO 10 K=1,KDIM
      XK=PI*FR*X(K)
      FF=(DSIN(XK))**MP
   10 F=F*FF
      FUNC3=F
      RETURN
      END
 
      FUNCTION FUNC4(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /EXACT/EXACT(10)
     A  /ABC/ABC(10),LABC(10)
      DIMENSION CENT(100,10), RVEC(100), X(1)
      DATA INIT/0/
      IF (INIT.GE.1) GO TO 2
      INIT=1
      KDIM = LABC(2)
      NSC = LABC(4)
      HSIZ = ABC(2)
      THSIZ = 2.*HSIZ
      PRINT 90, NSC,THSIZ
   90 FORMAT(1X,'*Func4: there are'I3'  small cubes with size'
     F F6.3/6X'  and the function =1 within those cubes'
     F  ' and =0 outside.'/5X,
     F  'In case of two overlapping cubes the value of function is'
     F  '  2'/5X' in the overlap volume, and so on')
      EXACT(4) = 0.
      DO 11 JSC=1,NSC
      CALL RANECU(RVEC,KDIM)
      EX1 = 1.
      DO 10 I=1,KDIM
      A = RVEC(I) - HSIZ
      IF (A.LT.0.) A = 0.
      B = RVEC(I) + HSIZ
      IF (B.GT.1.) B = 1.
      EX1 = EX1*(B-A)
   10 CENT(I,JSC) = RVEC(I)
      PRINT 91,JSC,(CENT(I,JSC),I=1,KDIM)
   91 FORMAT(1X,'*Peak #'I3'   Center:',5F7.4/(5X,10F7.4))
      EXACT(4) = EXACT(4) + EX1
   11 CONTINUE
    2 CONTINUE
      FUNC4 = 0.
      DO 30 JSC=1,NSC
      DO 20 K=1,KDIM
      IF(X(K).LE.CENT(K,JSC)-HSIZ.OR.X(K).GE.CENT(K,JSC)+HSIZ) GOTO 30
   20 CONTINUE
      FUNC4=FUNC4 + 1.
   30 CONTINUE
      RETURN
      END
 
      FUNCTION FUNC5(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /PI/PI,TPI,HPI,PI2,SQPI
     A   /ABC/ABC(10),LABC(10) /EXACT/EXACT(10)
      DIMENSION X(1)
      DATA INIT/0/
      IF (INIT.GE.1) GO TO 2
      INIT=1
      KDIM = LABC(2)
      A = ABC(2)
      FR = ABC(3)
      PIF = PI*FR
      EX = 1.
      DO 5 K=1,KDIM
    5 EX = EX*(A+(1.-DCOS(PIF))/PIF)
      EXACT(5) = EX
      PRINT 90, A,FR, EXACT(5)
   90 FORMAT(1X,'*FUNC5   A=',F8.2,'   FREQ=',F8.2,'  EXACT=',G12.4)
    2 CONTINUE
      F=1.
      DO 10 K=1,KDIM
      XK = PIF*X(K)
      FF = A + DSIN(XK)
   10 F=F*FF
      FUNC5 = F
C      PRINT 91, F, (X(K), K=1,KDIM)
C   91 FORMAT(1X,'func5=',G15.5/(1X,5G12.4))
      RETURN
      END

      FUNCTION FUNC6(V)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(1)
      COMMON /ABC/ABC(10),LABC(10)
      DATA INIT, IP/0,0/
      IF (INIT.EQ.0) THEN
        INIT = 1
        KPR2 = LABC(5)
C        IF (KPR2.EQ.0) PRINT 90, ABC, LABC
C   90   FORMAT(4(1X,' ABC=',5G12.5/),1X,'LABC=',10I6)
        A = ABC(2)
        B = ABC(3)
        CALL EXA(A,B)
      ENDIF
      IP = IP + 1
      FUNC6 = 1./((V(1) + V(2) - A)**2 + B**2)
      IF (IP.GT.LABC(7)) RETURN
      PRINT 91, IP, V(1), V(2), FUNC6
   91 FORMAT(1X,'Func6 ',I6,3G12.4)
      RETURN
      END
 
      FUNCTION FUNC7(U)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION U(1), Z(3), X(3), ALBIG(3,3)
      COMMON /ABC/ABC(10),LABC(10)
     A  /PI/PI,TPI,HPI,PI2,SQPI /EXACT/EXACT(10)
     B  /SMKEYS/KP(20),KY(20)
      DATA INIT, IP/0,0/
      IF (INIT.EQ.0) THEN
        INIT = 1
        KDIM = LABC(2)
        EPS = ABC(8)
        SIG1 = ABC(2)
        SIG2 = ABC(3)
        SIG3 = ABC(4)
        SIG1_2 = SIG1**2
        SIG2_2 = SIG2**2
        SIG3_2 = SIG3**2
        R12 = ABC(5)
        R13 = ABC(6)
        R23 = ABC(7)
        R12_2 = R12**2
        R13_2 = R13**2
        R23_2 = R23**2
        BRCT = (1. + 2.*R12*R13*R23 - R12_2 - R13_2 - R23_2)
        DET3 = BRCT*SIG1_2*SIG2_2*SIG3_2
        ALBIG(1,1) = (1. - R23)/(SIG1_2*BRCT)
        ALBIG(2,2) = (1. - R13)/(SIG2_2*BRCT)
        ALBIG(3,3) = (1. - R12)/(SIG3_2*BRCT)
        ALBIG(1,2) = (R13*R23 - R12)/(SIG1*SIG2*BRCT)
        ALBIG(1,3) = (R12*R23 - R13)/(SIG1*SIG3*BRCT)
        ALBIG(2,3) = (R12*R13 - R23)/(SIG2*SIG3*BRCT)
        ALBIG(2,1) = ALBIG(1,2)
        ALBIG(3,1) = ALBIG(1,3)
        ALBIG(3,2) = ALBIG(2,3)
        FACT0 = 8./DSQRT(DABS(DET3)*TPI**3)
        EXACT(7) = 1.
        print 90, det3, albig
   90   format(1x,'*det3=',g12.4/(1x,3g12.4))
      ENDIF
      FUNC7 = 0.
      DO 1 I = 1, 3
      IF (U(I).LT.EPS.OR.U(I).GT.(1.-EPS)) GO TO 100
    1 CONTINUE
      FACT = FACT0
      DO 3 I = 1, 3
      Z(I) = 2.*U(I) - 1.
      X(I) = DTAN(HPI*Z(I))
      FCT = HPI*(1. + X(I)**2)
      FACT = FACT*FCT
    3 CONTINUE
      SUM = 0.
       DO 12 I=1,KDIM
       DO 11 J=1,KDIM
  11   SUM = SUM + ALBIG(I,J)*X(I)*X(J)
  12   CONTINUE
       IF(SUM.LT.200.) GO TO 13
       F=0.
       GO TO 14
  13   F = DEXP(-0.5*SUM)
  14   FUNC7 = F*FACT
  100 IF (KP(14).EQ.0) RETURN
      PRINT 91, X, SUM, F, FACT
   91 FORMAT(1X,'f7',6G12.4)
      END

      FUNCTION FUNC8(V)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION V(1), ARG(8)
      COMMON /ABC/ABC(10),LABC(10) /EXACT/EXACT(10)
      DATA INIT, IP/0,0/
C      FF1(Z,P) = 0.5*(Z**2 + P**2)*DATAN(Z/P) - 0.5*Z*P
C      FF2(Z,P) = Z*DLOG(Z**2 + P**2) - 2.*Z + 2.*P*DATAN(Z/P)
      IF (INIT.EQ.0) THEN
        INIT = 1
        KPR2 = LABC(5)
        A = ABC(2)
        B = ABC(3)
        ALP = ABC(4)
        BET = ABC(5)
        GAM = ABC(6)
        ARG(1) = ALP + BET + GAM - A
        ARG(2) = -(ALP + BET - A)
        ARG(3) = -(BET + GAM - A)
        ARG(4) = BET - A
        ARG(5) = -(ALP + GAM - A)
        ARG(6) = ALP - A
        ARG(7) = GAM - A
        ARG(8) = A
        SUM1 = 0.
        SUM2 = 0.
        DO 8 I = 1, 8
        SUM1 = SUM1 + FF1(ARG(I),B)
        SUM2 = SUM2 + FF2(ARG(I),B)
    8   CONTINUE
        EXACT(8) = (SUM1/B - 0.5*SUM2)/(ALP*BET*GAM)
        PRINT 90, EXACT(8), SUM1, SUM2
   90   FORMAT(1X,'Exact_8 =',3G15.6)
      ENDIF
      IP = IP + 1
      FUNC8 = 1./((ALP*V(1) + BET*V(2) + GAM*V(3) - A)**2 + B**2)
      IF (IP.GT.LABC(7)) RETURN
      PRINT 91, IP, V(1), V(2), V(3), FUNC8
   91 FORMAT(1X,'Func8 ',I6,4G12.4)
      RETURN
      END
 
      FUNCTION FF1(Z,P)
      IMPLICIT REAL*8 (A-H,O-Z)
      FF1 = 0.5*(Z**2 + P**2)*DATAN(Z/P) - 0.5*Z*P
      RETURN
      END

      FUNCTION FF2(Z,P)
      IMPLICIT REAL*8 (A-H,O-Z)
      FF2 = Z*DLOG(Z**2 + P**2) - 2.*Z + 2.*P*DATAN(Z/P)
      RETURN
      END

      SUBROUTINE EXA(A,B)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/EXACT/EXACT(10)
      C1 = (2.-A)/B
      C2 = (1.-A)/B
      C3 = A/B
      AT1 = DATAN(C1)
      AT2 = DATAN(C2)
      AT3 = -DATAN(-C3)
      RL1 = DLOG((2.-A)**2 + B**2)
      RL2 = DLOG((1.-A)**2 + B**2)
      RL3 = DLOG(A**2 + B**2)
      EX = C1*AT1 - 0.5*RL1 - 2.*C2*AT2 + RL2 + C3*AT3 - 0.5*RL3
      EXACT(6) = EX
      PRINT 90, A,B,EX
   90 FORMAT(1X,'Exa  ',F10.2,F10.5,F16.4/)
C      PRINT 91, C1,C2,C3,AT1,AT2,AT3,RL1,RL2,RL3
C   91 FORMAT(1X,5G12.5)
      RETURN
      END
 
      real*8 function dfreq(x)
      real*8 x
      dfreq=0.0
      write(*,*) ' dummy DFREQ!!!'
      return
      end